package me.hammerle.snuviengine;

import me.hammerle.snuviengine.api.Engine;
import me.hammerle.snuviengine.api.IGame;
import me.hammerle.snuviengine.api.Renderer;

public class Game implements IGame
{
    private float oldX = 0;
    private float oldY = 0;
    private float x = 0;
    private float y = 0;
    
    private float power = 10;
    private final float size = 20;

    @Override
    public void tick()
    {        
        oldX = x;
        oldY = y;
        
        x += power;
        y += power;
        
        if(y > 300 || y < 0)
        {
            power = -power;
        }
    }
    
    @Override
    public void renderTick(Renderer r, float lag)
    { 
        r.setMixColorEnabled(false);
     
        r.translateTo(0.0f, 0.0f);
        r.updateMatrix();
        
        //lag = 0;
        float ix = oldX + (x - oldX) * lag;
        float iy = oldY + (y - oldY) * lag;
        
        r.setTextureEnabled(false);
        r.getColorRenderer().drawRectangle(ix, iy, ix + size, iy + size, 0xFF0000FF);
        
        
        float y = 200;
        r.setColorEnabled(true);
        r.setTextureEnabled(true);
        y = r.getFontRenderer().drawString(30, y, true, String.format("FPS: %.1f", Engine.getFramesPerSecond()));
        y = r.getFontRenderer().drawString(30, y, true, String.format("Nanos Per Tick: %d", Engine.getNanosPerTick()));
        y = r.getFontRenderer().drawString(30, y, true, String.format("TPS: %.1f", Engine.getTicksPerSecond()));
        y = r.getFontRenderer().drawString(30, y, true, String.format("Lag: %.1f", lag));
    }

    @Override
    public void onStop()
    {
    }
}
